--
-- Name: Harvester
-- Description: Minor enhancements for combines
-- Version: 1.0
-- Author: Saracaen
-- Date: 24/07/2011
--

Harvester = {};

-- Extended original functions --
function Harvester:load(xmlFile)
	
	self.isHarvesterEnabled = Utils.getNoNil(getXMLBool(xmlFile, "vehicle.features#harvester"), true);
	
end;

Combine.load = Utils.appendedFunction(Combine.load, Harvester.load);

function Harvester:update(dt)
	
	if self.isHarvesterEnabled then
		if self.isThreshing then
			local isImplementLowered = true;
			for cutter, implement in pairs(self.attachedCutters) do
				if not cutter:isLowered(false) then
					isImplementLowered = false;
				end;
			end;
			self.allowsThreshing = isImplementLowered;
		end;

		self.speedDisplayScale = 1.0;
	end;
	
end;

Combine.update = Utils.appendedFunction(Combine.update, Harvester.update);

function Harvester:detachImplement(implementIndex)	

	if self.isHarvesterEnabled then
		if self.grainTankCapacity == 0 or self.grainTankFillLevel == 0 then
			self.currentGrainTankFruitType = FruitUtil.FRUITTYPE_UNKNOWN;
		end;
	end;
		
end;

Combine.detachImplement = Utils.appendedFunction(Combine.detachImplement, Harvester.detachImplement);